#!/bin/bash
if [ $# -ne 1 ]; then
    echo "Usage: $0 <file_path>"
    exit 1
fi


current_develop(){
ostree_status=$(ostree admin status | grep '\*')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署"
    exit 1
fi
deploy_name=$(echo "$ostree_status" | awk '{print $2}')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署名称"
    exit 1  
fi
deploy_commit=$(echo "$ostree_status" | awk '{print $3}')
if [ $? -eq 0 ]; then
    echo "获取到当前的部署commit $deploy_name $deploy_commit"
    #commit=$(echo "$deploy_commit" | cut -d '.' -f 1)
    boot_path="/sysroot/ostree/deploy/${deploy_name}/deploy/${deploy_commit}/boot/"
    if [ "$1" == "in" ];then
	    if [ "$(ls -A $boot_path)" ]; then
            echo "boot目录不为空"
	    rm -rf $boot_path*
	    rsync -r -ac --inplace --xattrs --links /boot/* $boot_path
        fi
    elif [ "$1" == "out" ];then
	    if [ "$(ls -A $boot_path)" ]; then
            echo "boot目录不为空"
            rsync -r -ac --inplace --xattrs --links $boot_path* /boot/
	    else
            echo "$boot_path目录为空"
        fi
    fi
else
    echo "无法获取当前的部署commit"
    exit 1
fi
}
mode=$1
current_develop $mode



