#!/bin/bash
if [ $# -ne 2 ]; then
    echo "Usage: $0 <file_path>"
    exit 1
fi


current_develop(){
ostree_status=$(ostree admin status | grep '\*')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署"
    exit 1
fi
deploy_name=$(echo "$ostree_status" | awk '{print $2}')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署名称"
    exit 1  
fi
deploy_commit=$(echo "$ostree_status" | awk '{print $3}')
if [ $? -eq 0 ]; then
    echo "获取到当前的部署commit$deploy_commit"
    etc_copy="/sysroot/ostree/deploy/${deploy_name}/deploy/${deploy_commit}/usr"
    var_copy="/sysroot/ostree/deploy/${deploy_name}/deploy/${deploy_commit}"
   
    if [ "$1" == "etc" ];then
	if [ -d "$2" ];then
		echo "---copy $2---"
        if [ -d "$etc_copy${2}" ];then
       	    rsync -r -ac --inplace --xattrs --links $2/* $etc_copy${2}
        else
            mkdir -p $etc_copy${2}
            rsync -r -ac --inplace --xattrs --links $2/* $etc_copy${2}
        fi
	else
        if [ -d "$etc_copy$(dirname "$2")" ];then
		    rsync -r -ac --inplace --xattrs --links $2 "$etc_copy$(dirname "$2")"
        else
            mkdir -p "$etc_copy$(dirname "$2")"
            rsync -r -ac --inplace --xattrs --links $2 "$etc_copy$(dirname "$2")"
        fi
	fi
    else
	if [ -d "$2" ];then
		echo "---copy $2---"
        if [ -d "$var_copy${2}" ];then
       	    rsync -r -ac --inplace --xattrs --links $2/* $var_copy${2}
        else
            mkdir -p $var_copy${2}
            rsync -r -ac --inplace --xattrs --links $2/* $var_copy${2}
        fi
	else
        if [ -d "$var_copy$(dirname "$2")" ];then
		    rsync -r -ac --inplace --xattrs --links $2 "$var_copy$(dirname "$2")"
        else
            mkdir -p "$var_copy$(dirname "$2")"
            rsync -r -ac --inplace --xattrs --links $2 "$var_copy$(dirname "$2")"
        fi
	fi
    fi

else
    echo "无法获取当前的部署commit"
    exit 1
fi
}

type="$1"
path="$2"
current_develop $type $path


