#!/bin/bash
if [ $# -ne 3 ]; then
    echo "Usage: $0 <file_path>"
    exit 1
fi
current_develop(){
ostree_status=$(ostree admin status | grep '\*')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署名称"
    exit 1  
fi

deploy_name=$(echo "$ostree_status" | awk '{print $2}')
if [ $? -ne 0 ]; then
    echo "无法获取当前的部署名称"
    exit 1  
fi

deploy_commit=$(echo "$ostree_status" | awk '{print $3}')
if [ $? -eq 0 ]; then
    echo "获取到当前的部署commit$deploy_commit"
  
    etc_copy="/sysroot/ostree/deploy/${deploy_name}/deploy/${deploy_commit}/usr${3}"
    var_copy="/sysroot/ostree/deploy/${deploy_name}/deploy/${deploy_commit}${3}"
    if [ "$1" == "etc" ]; then
        if [ "$2" == "install" ];then
            if [ -e "$3" ]; then
                echo "File exists, performing restore $3..."
                diff_result=$(diff "$3" "$etc_copy")
                # 检查是否有差异
                if [ -z "$diff_result" ]; then
                    echo "$3没有差异"
                else
                    echo "$3有差异"
			        if [ -d "$3" ];then
                       	rsync -r -ac --inplace --xattrs --links $etc_copy/* $3
			        else
		                rsync -r -ac --inplace --xattrs --links $etc_copy $3
			        fi
                fi
            else
                if [ -d "$etc_copy" ];then #判断是文件还是目录
                    mkdir -p $3
                    rsync -r -ac --inplace --xattrs --links $etc_copy/* $3
                else
                    rsync -r -ac --inplace --xattrs --links $etc_copy $3
                fi
            fi
        else
            if [ -e "$3" ]; then
                echo "File exists, performing restore $3..."
                diff_result=$(diff "$3" "$etc_copy")
             # 检查是否有差异
                if [ -z "$diff_result" ]; then
                    echo "$3没有差异"
                else
                    echo "$3有差异"
                    ostree checkout --subpath=/usr${3} --union -C $commit $3
                     if [ $? -ne 0 ]; then
			            if [ -d "$3" ];then
                       	  rsync -r -ac --inplace --xattrs --links $etc_copy/* $3
			            else
		                 rsync -r -ac --inplace --xattrs --links $etc_copy $3
			            fi
                    fi
                fi
            else
                ostree checkout --subpath=/usr${3} --union -C $commit $3
                if [ $? -ne 0 ]; then
		            if [ -d "$3" ];then
                        mkdir -p $3
			            rsync -r -ac --inplace --xattrs --links $etc_copy/* $3
		            else
                   	    rsync -r -ac --inplace --xattrs --links $etc_copy $3
		            fi
                fi
            fi

        fi
    fi
    if [ "$1" == "var" ]; then
        if [ "$2" == "install" ];then
            if [ -e "$3" ]; then
                echo "File exists, performing checkout..."
                diff_result=$(diff "$3" "$var_copy")
             # 检查是否有差异
                if [ -z "$diff_result" ]; then
                    echo "$3没有差异"
                else
                    echo "$3有差异"
			        if [ -d "$3" ];then
                       	rsync -r -ac --inplace --xattrs --links $var_copy/* $3
			        else
		                rsync -r -ac --inplace --xattrs --links $var_copy $3
			        fi
                fi
            else
                if [ -d "$var_copy" ];then #判断是文件还是目录
                    mkdir -p $3
                    rsync -r -ac --inplace --xattrs --links $var_copy/* $3
                else
                    rsync -r -ac --inplace --xattrs --links $var_copy $3
                fi
            fi
        else
            if [ -e "$3" ]; then
                echo "File exists, performing checkout..."
                diff_result=$(diff "$3" "$var_copy")
             # 检查是否有差异
                if [ -z "$diff_result" ]; then
                    echo "$3没有差异"
                else
                    echo "$3有差异"
                    ostree checkout --subpath=/usr${3} --union -C $commit $3
                     if [ $? -ne 0 ]; then
			            if [ -d "$3" ];then
                       	  rsync -r -ac --inplace --xattrs --links $var_copy/* $3
			            else
		                  rsync -r -ac --inplace --xattrs --links $var_copy $3
			            fi
                    fi
                fi
            else
                ostree checkout --subpath=/usr${3} --union -C $commit $3
                if [ $? -ne 0 ]; then
		            if [ -d "$3" ];then
                        mkdir -p $3
			            rsync -r -ac --inplace --xattrs --links $var_copy/* $3
		            else
                   	    rsync -r -ac --inplace --xattrs --links $var_copy $3
		            fi
                fi
            fi

        fi
    fi
else
    echo "无法获取当前的部署commit"
    exit 1
fi
}

path_type="$1"
type="$2"
path="$3"
echo "coredata restore $1 $2 $3"
current_develop $path_type $type $path
